grammar R;

@header {
import java.util.HashMap;
}

@members {
HashMap memory = new HashMap();
}

prog:   stat+ ;

stat:   'print('expr')' NEWLINE # printExpr
    |   ID '<-' expr NEWLINE {memory.put($ID.text, new Integer($expr.value));} # assign
    |   loopStatement # loop
    |   NEWLINE #blank
    ;

loopStatement:   'repeat' NEWLINE? '{'stat*'}'   #repeat
    ;
expr returns [int value]
    :   e=multExpr {$value = $e.value;}
        (   '+' e=multExpr {$value += $e.value;}
        |   '-' e=multExpr {$value -= $e.value;}
        )*
    ;

multExpr returns [int value]
    :   e=atom {$value = $e.value;} ('*' e=atom {$value *= $e.value;})*
    |   e=atom {$value = $e.value;} ('/' e=atom {$value /= $e.value;})*
    ;

atom returns [int value]
    :   INT {$value = Integer.parseInt($INT.text);}
    |   ID
        {
            Integer v = (Integer)memory.get($ID.text);
            if ( v!=null ) $value = v.intValue();
            else System.err.println("undefined variable "+$ID.text);
        }
    |   '(' expr ')' {$value = $expr.value;}
    ;

ID  :   ('a'..'z'|'A'..'Z')+ ;
INT :   '0'..'9'+ ;
NEWLINE:'\r'? '\n' ;